<?php
/**************************************************
  Coppermine 1.5.x Plugin - BDW (Bild der Woche)
  *************************************************
  Copyright (c) TankerTom 2012
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
**************************************************/
  
if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

$thisplugin->add_action('plugin_install',  'bdw_install');
$thisplugin->add_action('plugin_configure','bdw_configure');
$thisplugin->add_action('plugin_uninstall','bdw_uninstall');
$thisplugin->add_action('plugin_cleanup',  'bdw_cleanup');

$superCage = Inspekt::makeSuperCage();
$url_bdw = $superCage->server->getRaw('REQUEST_URI');

if (!preg_match("/cat/i", $url_bdw) && !preg_match("/index-/i", $url_bdw)){
  $thisplugin->add_filter('plugin_block','bdw_main');
  $thisplugin->add_filter('page_meta','bdw_head');
}

function bdw_install()
{
  $superCage = Inspekt::makeSuperCage();

	global $CONFIG, $lang_plugin_code_bdw, $thisplugin;
           require('plugins/bdw/include/init.inc.php');

	if ($superCage->post->getAlnum('submit') == $lang_plugin_code_bdw['button_install']) {
          if(mysql_num_rows(cpg_db_query("SHOW TABLES LIKE '{$CONFIG['TABLE_BDW']}'"))==0) {
            require 'include/sql_parse.php';
		// create table	
		$db_schema = $thisplugin->fullpath . '/schema.sql';
		$sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
		$sql_query = preg_replace('/cpg_/', $CONFIG['TABLE_PREFIX'], $sql_query);

		$sql_query = remove_remarks($sql_query);
		$sql_query = split_sql_file($sql_query, ';');

		foreach($sql_query as $q) { 
			cpg_db_query($q);
		}
          }
		return true;
	} else {
		return 1;
	}
}

function bdw_configure()
{
	$superCage = Inspekt::makeSuperCage();
        $request_uri = $superCage->server->getEscaped('REQUEST_URI');

        global $CONFIG, $lang_plugin_code_bdw, $thisplugin;
	   require('plugins/bdw/include/init.inc.php');
        
	echo <<< EOT
		<h2>{$lang_plugin_code_bdw['install_click']}</h2>
		{$lang_plugin_code_bdw['install_note']}<br />
		<br />
		<form action="$request_uri" method="post">
		<input type="submit" value="{$lang_plugin_code_bdw['button_install']}" name="submit" />
		</form>
EOT;
}

function bdw_uninstall()
{
	$superCage = Inspekt::makeSuperCage();
        global $CONFIG, $lang_plugin_code_bdw, $thisplugin;
	   require('plugins/bdw/include/init.inc.php');

        if (!$superCage->post->keyExists('drop')) 
       {
        return 1;
       }
	if ($superCage->post->getInt('drop')== 1)
        {
        if ($CONFIG['bdw_path'] != $CONFIG['userpics']){
          rmdir("./".$CONFIG['fullpath'].$CONFIG['bdw_path']);
         }else{
           $CONFIG['TABLE_BDW'] = $CONFIG['TABLE_PREFIX'].'plugins_bdw';
          $bdw = cpg_db_query("SELECT * FROM {$CONFIG['TABLE_BDW']}");
           while($row = mysql_fetch_array($bdw, MYSQL_ASSOC)) {
           $from = $CONFIG['fullpath'].$row['filepath'].$CONFIG['bdw_vor_1'].$row['filename'];
           unlink($from);
           }
         }
	    cpg_db_query("DROP TABLE IF EXISTS {$CONFIG['TABLE_PREFIX']}plugins_bdw");
	    cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='bdw_vor'");
	    cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='bdw_vor_1'");
            cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='bdw_cron'");
            cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='bdw_random'");
            cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='bdw_path'");
            cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name='bdw_archiv'");
            cpg_db_query("ALTER TABLE {$CONFIG['TABLE_PICTURES']} DROP bdw");
            cpg_db_query("ALTER TABLE {$CONFIG['TABLE_PICTURES']} DROP bdw_selection");
            if (file_exists('./cron_bdw.php')){unlink('./cron_bdw.php');}
        }
	return true;
}

function bdw_cleanup($action)
{
    $superCage = Inspekt::makeSuperCage();
    $request_uri = $superCage->server->getEscaped('REQUEST_URI');

    global $CONFIG, $lang_plugin_code_bdw, $thisplugin;
       require('plugins/bdw/include/init.inc.php');
   
    if ($action===1) {
         echo <<< EOT
    <form action="$request_uri" method="post">
        <p>
            {$lang_plugin_code_bdw['cleanup_question']}
        </p>
        <div style="margin:25;">
        <table border="0" cellspacing="0" cellpadding="0">&nbsp;
            <tr>
                <td><input type="radio" name="drop" value="1" /></td>
                <td>{$lang_plugin_code_bdw['Yes']}</td>
            </tr>
            <tr>
                <td><input type="radio" name="drop" checked="checked" value="0" /></td>
                <td>{$lang_plugin_code_bdw['No']}</td>
            </tr>
        </table>&nbsp;
        </div>
        <span>
           <input type="submit" name="submit" value="{$lang_plugin_code_bdw['button_submit']}" /> &nbsp;&nbsp;
           <input type="button" name="cancel" onClick="window.location='pluginmgr.php';" value="{$lang_plugin_code_bdw['button_cancel']}" />
        </span>
    </form>
EOT;
    }
}

function bdw_head($meta) { 
$meta .=<<<EOT
<link rel="stylesheet" href="plugins/bdw/css/style.css" type="text/css" />
EOT;
  return $meta;
}


function bdw_main($block_bdw){

global $CONFIG, $lang_plugin_code_bdw, $lang_plugin_config_bdw, $LINEBREAK, $matches, $thisplugin, $width, $zebra_class, $arch;
require('plugins/bdw/include/init.inc.php');

if($matches[1] != 'bdw') {
      return $matches;
    } 
    
$bdw = cpg_db_query("SELECT * FROM {$CONFIG['TABLE_PICTURES']} WHERE bdw = '$kw_year' Limit 1");
   if (!$bdw) { die('<p>Error performing query: ' . mysql_error() . '</p>');}

while($row = mysql_fetch_array($bdw, MYSQL_ASSOC)) {
   $Path     = $CONFIG['ecards_more_pic_target'];
   $title    = $row['title'];
   $dd       = $row['mtime'];
   $filepath = $row['filepath'];
   $filename = $row['filename'];
   $ownerid  = $row['owner_id'];
   $pwidth   = $row['pwidth'];
   $pheight  = $row['pheight'];
   $rest = substr($row['filepath'], -6,-1);
   if ($row['bdw'] <> 1 ){$pos = $row['pid'];}
   $bdw_owner = cpg_db_query("SELECT user_name FROM {$CONFIG['TABLE_USERS']} WHERE user_id = $ownerid");
     $raw = mysql_fetch_row($bdw_owner);
      $ownername = $raw[0];
      $bdw_selc = $row['bdw_selection'];
      if ($row['bdw_selection'] == 1){
         $im = $lang_plugin_code_bdw['config_images_1'];
      }elseif ($row['bdw_selection'] == 2){
         $im = $lang_plugin_code_bdw['config_images_2'];
      }else{
         $im = $lang_plugin_code_bdw['config_images_3'];
      }
   if ($CONFIG['bdw_path'] != $CONFIG['userpics']){
       $from     = $CONFIG['fullpath'] . $row['filepath'] . $CONFIG['bdw_vor'] . $row['filename'];
       $to       = $CONFIG['fullpath'] . $CONFIG['bdw_path'] . $CONFIG['bdw_vor_1'] . $row['filename'];
       $filepath = substr_replace($filepath, $CONFIG['bdw_path'], 0, 15);
     }else{
       $from     = $CONFIG['fullpath'] . $row['filepath'] . $CONFIG['bdw_vor'] . $row['filename'];
       $to       = $CONFIG['fullpath'] . $row['filepath'] . $CONFIG['bdw_vor_1'] . $row['filename'];
   }
}

if (file_exists($to)) {
    }else{
   if (!copy($from, $to)){
      echo "das Anlegen schlug fehl...\n";
    }else{
      $sql = "INSERT INTO {$CONFIG['TABLE_BDW']}(pid, filepath, filename, title, owner_id, kw_year) VALUES ('$pos','$filepath','$filename','$title','$ownerid','$kw_year')";
      cpg_db_query($sql);
    }
}
if ($CONFIG['bdw_archiv'] == '1') {
    $arch = '<td align="center"><span class="thumb_title"><a href="index.php?file=bdw/archiv">Archiv</a><br><br></span></td>';
    }

if ($pwidth > $pheight){
    $pcellsp = '10';
 }else{
    $pcellsp = '0';
}

starttable("100%", $icon_array['lob'].$lang_plugin_config_bdw['display_name'], 1);
echo <<<EOT
<table align="center" width="$width" cellspacing="1" cellpadding="0" class="maintable $zebra_class">
  <td valign="top" class="thumbnails_bdw" width ="25%" align="center">
    <table width="100%" cellpadding="0" cellspacing="$pcellsp">
      <tr>
	<td align="center"><b><u>Bild der Woche <br /></u></b>
          <span class="thumb_title">ermittelt: {$im}</span>
          <a href="{$CONFIG['ecards_more_pic_target']}displayimage.php?pid={$pos}"><img src="{$CONFIG['ecards_more_pic_target']}{$from}" class="image" alt= Klicke hier wenn das Bild nicht sichtbar ist></a>
        </td>
        <tr><td align="center"><span class="thumb_title">$title</span></td></tr>
        <tr><td align="center"><span class="thumb_title">Fotograf: <a href="{$CONFIG['ecards_more_pic_target']}index.php?cat={$rest}">{$raw[0]}</a></span></td></tr>
        <tr>{$arch}</tr>
        <!--tr><td align="center"><span class="thumb_title"><a href="javascript:alert('Verweisziel noch nicht erreichbar')">Archiv</a><br><br></span></td></tr-->
      </tr>
    </table>    
  </td>
</table>
<img src="images/spacer.gif" width="1" height="7" border="" alt="" /><br />
EOT;
endtable();
mysql_free_result($bdw);
mysql_free_result($bdw_owner);
ob_end_flush();

}

?>